﻿(function () {

    "use strict";

    angular.module("enrDetailsPaneModule")
           .directive("detailsNoResultsReported", [function () {
               return {
                   templateUrl: "Scripts/EnrAngular/EnrDetailsPane/detailsNoResultsReported.html",
                   scope: { },
                   controller: "detailsNoResultsReportedController",
                   restrict: "E"
               };
           }])

           .controller("detailsNoResultsReportedController", ["$scope", "mapSelectedRegion", "detailsData", "enrModeManager", "participationCalculator", function ($scope, mapSelectedRegion, detailsData, enrModeManager, participationCalculator) {

               // Visibility Handling
               var determineVisibility = function () {
                   var isVisible = false;

                   if (mapSelectedRegion.isAnyRegionSelected()) {
                       if (enrModeManager.isReferendumsMode())
                           isVisible = !participationCalculator.isReferendumsRegionParticipatingFromDetailedJson(detailsData.getData());
                       else if (enrModeManager.isOfficeMode())
                           isVisible = !participationCalculator.isOfficesRegionParticipating(detailsData.getData(), mapSelectedRegion.getSelectedRegionProperties());
                   }

                   return isVisible ? "" : "hidden";
               };
               $scope.componentVisible = determineVisibility();
               $scope.$on(mapSelectedRegion.regionChangeEventName, function () {
                   $scope.componentVisible = determineVisibility();
               });
               $scope.$on(detailsData.dataChangedEventName, function () {
                   $scope.componentVisible = determineVisibility();
               });
           }]);

}());
